const userInfoDiv = document.getElementById("userInfo")
const userInfoPopup = document.getElementById("userPopup")
const userInfoglobal = document.getElementById("userInfoglobal")

const musicTitle = document.getElementById("music_title")
const musicURL = document.getElementById("music_img")

const durationBar = document.getElementById("duration")
const durationTextAct = document.getElementById("durationTextAct")
const durationTextTotal = document.getElementById("durationTextTotal")

const backward = document.getElementById("backward")
const play = document.getElementById("play")
const forward = document.getElementById("forward")


const settingsBtn = document.getElementById("settings_btn")



const loop = document.getElementById("loop")
const vol = document.getElementById("volbtn")
const shuffle = document.getElementById("shuffle")
const list = document.getElementById("list_btn")
const takeCurrent =  document.getElementById("takeCurrent")

const volBox = document.getElementById("volumeBox")
const volTxt = document.getElementById("volumeTxt")
const volDiv = document.getElementById("volDiv")
const volRange = document.getElementById("volumeInput")

const listBox = document.getElementById("listBox")
const listNumber = document.getElementById("listNumber")

const disconnect = document.getElementById("disconnect")

const userInfo = get("USER_INFO")

const report_dialog = document.getElementById("report_dialog")
const report_close = document.getElementById("report_close")
const reportBtn = document.getElementById("reportBtn")
const report_level =  document.getElementById("report_level")
const report_desc =  document.getElementById("report_desc")
const report_send =  document.getElementById("report_send")

const searchBtn = document.getElementById("search_btn")
const homeBtn = document.getElementById("home_btn")
const mainView = document.getElementById("mainView")

const restartBtn = document.getElementById("restartBtn")
const WelcomeContent = mainView.firstElementChild.outerHTML
const playlistContent = document.getElementById("playlist-content")


var wasOnPlaylist = false
var wasOnHome = false

var playlistSelected = null
var playlistValue = null
var deleteJustBefore = null
var currentSong = null

var isAdmin = false
var playlistAvailable = null








restartBtn.addEventListener("click", () => {

    get("RESTART")
})



homeBtn.style.color = "white"

var xMousePos = 0;
var yMousePos = 0;

const tooltip = document.getElementById("tooltip")

tooltip.style.visibility = 'hidden'
tooltip.style.display = 'none'
const alreadyDeclare = new Array()

document.onmousemove = function(e)
{
  xMousePos = e.clientX + window.scrollX;
  yMousePos = e.clientY + window.scrollY;

  showToolTip("radio_add", "Ajouter par l'URL", e)
  showToolTip("sendplaylist", "Envoyer la playlist", e)
  showToolTip("playlistplay", "Jouer la playlist", e)
  showToolTip("playlistdelete", "Effacer la playlist", e)
  showToolTip("an_create", "Ajouter un serveur", e)
  showToolTip("pplay", "Jouer maintenant", e)
  showToolTip("delete", "Supprimer", e)
  showToolTip("add", "Ajouter à la liste de lecture", e)
  showToolTip("backward", "Précédent", e)
  showToolTip("forward", "Suivant", e)
  showToolTip("lmore", "Plus d'options", e)
  showToolTip("loop", "Répéter le titre", e)
  showToolTip("shuffle", "Mélanger la liste de lecture", e)
  showToolTip("list_btn", "Liste de lecture", e)
  showToolTip("disconnect", "Déconnecter le bot", e)
  showToolTip("reload", "Relancer le serveur", e)
  showToolTip("admin", "Donner les permissions", e)
  showToolTip("takeCurrent", "Ajouter le titre à une playlist", e)
  showToolTip("volbtn", "Volume", e)
 
};



function showToolTip(id, text, e) {

    if(e.target) {
        
        if(e.target.id.includes(id)) {

            if(!alreadyDeclare.includes(e.target.id)) {
                alreadyDeclare.push(e.target.id)
                const elementAssociate = document.getElementById(e.target.id)

                elementAssociate.addEventListener("mousemove", () => {
                    tooltip.style.visibility = 'visible'
                    tooltip.style.display = 'unset'
                    tooltip.style.top = ( yMousePos - ( tooltip.offsetHeight + 20)) + "px"
                    tooltip.style.width = "150px"
                    tooltip.style.left =(xMousePos - 75 )+ "px"
                    tooltip.innerHTML = text
    
                })
                    
                elementAssociate.addEventListener("mouseleave", () => {

                    
                    alreadyDeclare.splice(alreadyDeclare.indexOf(e.target.id), 1)

                    tooltip.style.visibility = 'hidden'
                    tooltip.style.display = 'none'
                    
                })

            }        

        
        } 

    }

    

    
}

homeBtn.addEventListener("click", () => {

    wasOnHome = true
    loadHome()

})




function loadHome() {

    wasOnHome = true

    mainView.innerHTML = WelcomeContent
    wasOnPlaylist = false
   

    get("ALL_CONNECTED_USER")


    get("ALL_RADIO")

   
    
}

socket.on("ALWAYS/ALL_CONNECTED_USER", (resp) => {

    if(wasOnHome) {

        const website_list = document.getElementById("website_list")
        const userToPush = new Array()
    
        userToPush.push("<p style=' padding-bottom: 1%; font-family: Gunship, sans-serif;'><i class='fa fa-users'></i> Personnes en ligne</p>")
    
        for(var user of resp ) {

            var textshadow = ""
       
            
            if(user.admin == true) {

                textshadow = 'box-shadow: #fcff4d 0px 0px 8px;'
            }

            if(user.username == "raphixscrap") {
                textshadow = 'box-shadow: #ac7599 0px 0px 8px'

            }

            userToPush.push(`<div id='${resp.indexOf(user)}' style='padding-left: 2%; padding-bottom: 2%; padding-top: 1%;' class="set_user_info"><img  style='margin-right: 3%; ${textshadow}' src="https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}"><div style="display: flex; flex-direction: column; justify-content: center;"><p class="INDEX_gbname">${user.global_name}</p><p class="INDEX_usrname">${user.username}</p></div></div>`)
    
        }
    
        website_list.innerHTML = userToPush.join("")
    }
    
})

socket.on("ALWAYS/ALL_RADIO", (resp) => {

    if(wasOnHome) {

    const radio_list = document.getElementById("radio_list")
    const radioToPush = new Array()

    radioToPush.push("<p style='font-family: Gunship, sans-serif;'><i class='fa fa-radio'></i> Radio</p>")
    radioToPush.push(`
    <dialog class="report_dialog" id="radio_dialog">
            <div class="rlineclose">
                <p class="rtitle"><i class="fa fa-radio"></i> Ajout d'une radio</p>
                <button id="radio_close" class="report_close"><i class="fa-solid fa-xmark"></i></button>
            </div>
            <p id='radio_info' style='text-align: center; color: red;'></p>

            <div class="rcontent">
                <p class="runder">URL</p>
                <input type='text' id="radio_host">
                <button id="radio_send" class="rsend"><i class="fa-solid fa-plus"></i> Ajouter</button>
            </div>
    </dialog>
`)

   

    for(var title of resp ) {

        var thumbnail = title.thumbnail
        if(!thumbnail) {
   
           thumbnail = "/images/black-image.svg"
                           
         }

        radioToPush.push(`<div style='grid-template-columns: 0.5fr 7fr 1fr !important;' class="search_song"> <img style='width: 60px;height: 45px; margin-right: 10px;' src="${thumbnail}"><div class="search_titleSong"> <p class="search_title">${title.title} - ${title.author}</p></div><button id='${resp.indexOf(title)}_radio_pplay' class='primary'><i class='fa fa-play'></i></button></div>`)

    }

    if(isAdmin) {

        radioToPush.push(`
        <div id="radio_add" class="playlist_div"><i style='margin-right: 10px;' class='fa fa-plus'></i> Ajouter une radio</div>`)
    }

    radio_list.innerHTML = radioToPush.join("")

    if(isAdmin) {
    
        

    const radio_dialog = document.getElementById("radio_dialog")
    const radio_close = document.getElementById("radio_close")
    const radio_send = document.getElementById("radio_send")
    const radio_add = document.getElementById("radio_add")
    const radio_info = document.getElementById("radio_info")
    const radio_host = document.getElementById("radio_host")

    if(radio_add) {
        radio_add.addEventListener("click", () => {
            radio_info.innerHTML = ""
            radio_host.value = ""
            radio_dialog.showModal()
        })
    
        radio_close.addEventListener("click", () => {
            radio_info.innerHTML = ""
            radio_dialog.close()
        })
    
        radio_send.addEventListener("click", () => {
            if(radio_host.value != '') {
    
                send("RADIO/ADD", radio_host.value)
                radio_dialog.close()
            } else {
               
                radio_info.innerHTML = "Remplissez une URL !"
            }
       
        })

    }

   

    }

    for(var title of resp ) {

        const playBtn = document.getElementById(resp.indexOf(title) +'_radio_pplay')
    
        playBtn.addEventListener("click", () => {

            send("ADD_SONG_NOW", resp[playBtn.id.replace("_radio_pplay", "")])

        })
    }



    }
})

loadHome()

function delPlayList(key) {

    send("DELETE_PLAYLIST", key)
    mainView.innerHTML = WelcomeContent
    playlistSelected = null
    playlistValue = null

}


function playPlayList(key) {

    send("PLAY_PLAYLIST", key)
 

}

function sendPlayList(key) {

    const playlist_popup = document.getElementById("playlist_popup")

    if(playlist_popup) {

        get("USER_LIST").then(resp => {

            const userToPush = new Array()

            for(var user of resp) {

                userToPush.push(`<div id='${resp.indexOf(user)}' style='padding: 1%;' class="INDEX_line set_user_info"><img src="https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}"><div style="display: flex; flex-direction: column; justify-content: center;"><p class="INDEX_gbname">${user.global_name}</p><p class="INDEX_usrname">${user.username}</p></div></div>`)

            }

            playlist_popup.innerHTML = userToPush.join("")
            playlist_popup.style.width = '170px'
            playlist_popup.style.top = (yMousePos - 30) + "px"
            playlist_popup.style.left = (xMousePos - 165) + "px"
            playlist_popup.classList.remove("invisible")


            playlist_popup.addEventListener("mouseleave", () => {
            
                playlist_popup.classList.add("invisible")

            })

            for(var user of resp) {

                const userElement = document.getElementById(resp.indexOf(user))

                userElement.addEventListener("click", () => {

                    playlist_popup.classList.add("invisible")
                    send("SEND_PLAYLIST", key, resp[userElement.id].id)
                })
            }
    
            //send("SEND_PLAYLIST", key, user.id)
    
        })
    }

    
 
}

socket.on("DO_UPDATE_PLAYLIST", () => {

    get("PLAYLIST")
})

get("PLAYLIST")

socket.on("ANSWER/GET/PLAYLIST", (data) => {
    var contentToPush = new Array()
    var selectionData = new Array()


    contentToPush.push('<div id="createPlaylist" class="playlist_div"><i class="fa-solid fa-plus playlist_tile"></i> Créer une playlist</div>')


    for (const [key, value] of Object.entries(data)) {

        contentToPush.push('<div id="' + key + '_playlist" class="playlist_div checker"><img class="playlist_tile" src="/images/playlist-tile.svg"><p>' + key + '</p></div>')
        selectionData.push('<option style="color: black;">' + key +  '</option>')
    }
    

    

    if(contentToPush.join("") == "") {
        
        playlistContent.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
    
    } else {

        playlistContent.innerHTML = contentToPush.join("")
        playlistAvailable = selectionData
    }

    if(playlistSelected && deleteJustBefore || playlistSelected && wasOnPlaylist) {
        deleteJustBefore = null
        loadPlaylist(playlistSelected, data[playlistSelected])   
    }

    for (const [key, value] of Object.entries(data)) {

        const playlist_selector = document.getElementById(key + '_playlist')

        playlist_selector.addEventListener("click", () => {
            
            loadPlaylist(key, value) 
            wasOnPlaylist = true           

        })
    }

    const buttons = document.querySelectorAll(".checker");

    buttons.forEach(button => {
        button.addEventListener("click", function () {
            buttons.forEach(btn => {
                if (btn === button) {
                    btn.style.color = "white";
                } else {
                    btn.style.color = "";
                }
            });
        });
    });
    
    
    const addPlaylist = document.getElementById("createPlaylist")
    const addPlaylist_dialog = document.getElementById("createPlaylist_dialog")
    const addPlaylist_close = document.getElementById("createPlaylist_close")
    const apText = document.getElementById("apText")
    const apCreate = document.getElementById("apCreate")


    addPlaylist_close.addEventListener("click", () => {
        
        addPlaylist_dialog.close()
    })

    addPlaylist.addEventListener("click", () => {
        
        apText.value = ""
        addPlaylist_dialog.showModal()
    })

    apCreate.addEventListener("click", () => {

        addPlaylist_dialog.close()
        send("CREATE_PLAYLIST", apText.value)
        
    })

  
    
    console.log(data)
})

function loadPlaylist(key, value) {

    wasOnHome = false

    var playlistToPush = new Array()
    var playlist_songs = new Array()

    playlistSelected = key
    playlistValue = value

    for(var title of value) {

            var PFormatduration = null
            pdurationAll = title.duration

            const pmaxhours = Math.floor(pdurationAll / 3600000);

            var pmaxmin = Math.trunc(pdurationAll / 60000) - (Math.floor(pdurationAll / 60000 / 60) * 60);
            var pmaxsec = Math.floor(pdurationAll / 1000) - (Math.floor(pdurationAll / 1000 / 60) * 60);

          
            if (pmaxsec < 10) {
                pmaxsec = `0${pmaxsec}`;
            }


            if(pmaxhours != 0) {

                if (pmaxmin < 10) {
                    pmaxmin = `0${pmaxmin}`;
                }

                
                pmax = pmaxhours + ":" + pmaxmin + ":" + pmaxsec
            } else {
                pmax =  pmaxmin + ":" + pmaxsec
            
            }

            PFormatduration = pmax

            var thumbnail = title.thumbnail
    
            if(!thumbnail) {

                thumbnail = "/images/black-image.svg"
                        
            }

            if(title.duration == 9223372036854776000) {

                PFormatduration = "<i style='color: red;' class='fa-solid fa-circle'></i> LIVE"
            }

        playlist_songs.push('<div class="search_song"> <img class="search_thumbnail" src="' + thumbnail + '"><div class="search_titleSong"> <p class="search_title">' + title.title + '</p></div> <p>' + title.author + '</p><p>' + PFormatduration + '</p> <div class="search_buttons"><button id="' + value.indexOf(title) +  '_padd" class="search_add"><i class="fa fa-plus"></i></button><button id="' + value.indexOf(title) +  '_pplay" class="search_lmore"><i class="fa fa-play"></i></button><button id="' + value.indexOf(title) +  '_pdelete" style="font-size: 20px;" class="list_delete"><i class="fa fa-trash"></i></button></div></div>')

    }



    playlistToPush.push(`<div class="INDEX_userPopup invisible" id="playlist_popup"></div>`)
    playlistToPush.push('<div class="apPres"><div class="apTitle"><img class="apTile" src="/images/playlist-tile.svg"><p class="apName">' + key + '</p></div><div class="apButtons"><button onclick="playPlayList(\''+ key +'\')" id="'+ key +'_playlistplay" class="primary"><i class="fas fa-play"></i><button onclick="sendPlayList(\''+ key +'\')" id="sendplaylist" class="list_upSong"><i class="fas fa-paper-plane"></i></button></button><button onclick="delPlayList(\''+ key +'\')" id="playlistdelete" class="list_delete"><i class="fas fa-trash"></i></button></div></div><hr>' + playlist_songs.join(""))
    
    if(playlistToPush.join("") == "") {

        mainView.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
    
    } else {

        mainView.innerHTML = playlistToPush.join("")

        
    }

    for(var title of value) {

        const add_to = document.getElementById(value.indexOf(title) + "_padd")
        const playNow = document.getElementById(value.indexOf(title) + "_pplay")
        const deleteBtn = document.getElementById(value.indexOf(title) + "_pdelete")

        add_to.addEventListener("click", () => {

            send("ADD_SONG", value[add_to.id.replace("_padd", "")])
        })

        playNow.addEventListener("click", () => {
     
            send("ADD_SONG_NOW", value[add_to.id.replace("_padd", "")])

        })

        deleteBtn.addEventListener("click", () => {

            deleteJustBefore = true
            send("DELETE_SONG_TO_PLAYLIST", key, value[add_to.id.replace("_padd", "")])
            
        })

    
    }

}



searchBtn.addEventListener("click", () => {

    mainView.innerHTML = '<div class="findbar"><i class="fa fa-search"></i><input autofocus  id="searchBar" placeholder="Insérez des mots-clés ou un lien" type="text"></div><div class="search_middle"></div><div id="search_content"></div>'
    const searchBar = document.getElementById("searchBar")
    const searchcontent = document.getElementById("search_content")

    wasOnPlaylist = false

    searchBar.addEventListener("change", () => {

    
        send("SEARCH", searchBar.value).then(answerOfResult => {
            
            var results = answerOfResult.results
            var playlistReconnised = answerOfResult.playlist

            if(!playlistReconnised) {

            if(results.tracks != null) {
                const data = results.tracks
             
                console.log(data)
                var contentToPush = new Array()
        
                for(var title of data) {
                    
                    var PFormatduration = null
                    pdurationAll = title.duration

                    const pmaxhours = Math.floor(pdurationAll / 3600000);

                    var pmaxmin = Math.trunc(pdurationAll / 60000) - (Math.floor(pdurationAll / 60000 / 60) * 60);
                    var pmaxsec = Math.floor(pdurationAll / 1000) - (Math.floor(pdurationAll / 1000 / 60) * 60);

                
                    if (pmaxsec < 10) {
                        pmaxsec = `0${pmaxsec}`;
                    }

   
                    if(pmaxhours != 0) {

                        if (pmaxmin < 10) {
                            pmaxmin = `0${pmaxmin}`;
                        }

                        
                        pmax = pmaxhours + ":" + pmaxmin + ":" + pmaxsec
                    } else {
                        pmax =  pmaxmin + ":" + pmaxsec
                    
                    }

                    var thumbnail = title.thumbnail
    
                    if(!thumbnail) {

                        thumbnail = "/images/black-image.svg"
                    }

                    
                    PFormatduration = pmax

                    if(title.duration == 9223372036854776000) {

                        PFormatduration = "<i style='color: red;' class='fa-solid fa-circle'></i> LIVE"
                    }

                    contentToPush.push(' <div class="search_song"> <img class="search_thumbnail" src="' + thumbnail + '"><div class="search_titleSong"> <p class="search_title">' + title.title + '</p></div> <p>' + title.author + '</p><p>' + PFormatduration + '</p> <div class="search_buttons"><button id="' + data.indexOf(title) +  '_ladd" class="search_add"><i class="fa fa-plus"></i></button> <div class="searchMoreDiv"><button id="' + data.indexOf(title) + '_lmore" class="search_lmore"><i class="fa-solid fa-ellipsis"></i></button></div><div class="searchPopup" id="' + data.indexOf(title) + '_popup"><div id="' + data.indexOf(title) + '_playNow" class="INDEX_line"><i class="fa-solid fa-play"></i> Lire maintenant</div><div id="' + data.indexOf(title) +'_goPlaylist" class="INDEX_line"><i class="fa-regular fa-square-plus"></i> Ajouter à une playlist</div><div id="' + data.indexOf(title) +'_copy" class="INDEX_line"><i class="fa-regular fa-copy"></i> Copier le lien</div></div></div><dialog id="' +  data.indexOf(title) + 'playlistManager" class="report_dialog"><div class="rlineclose"><p class="rtitle"><i class="fa fa-square-plus"></i> Ajouter à une playlist</p><button id="' +  data.indexOf(title) + 'playlistManager_close" class="report_close"><i class="fa-solid fa-xmark"></i></button></div><div class="apContent"><img id="' +  data.indexOf(title) + 'playlist_add_img" class="ppTile" src="/images/playlist-tile.svg"><p style="padding: 1%;" id="' +  data.indexOf(title) + 'playlist_add_music"></p><p>Selectionner la playlist</p><select style=" color: white; background-color: transparent; border: solid 2px #2c3df4;padding: 1%; border-radius: 12px;" id="' +  data.indexOf(title) + 'playlistSelection"></select><button id="' +  data.indexOf(title) + 'playlistAddSong" class="rsend"><i class="fa fa-plus"></i> Ajouter</button></div></dialog></div>')
                }
        
                if(contentToPush.join("") == "") {
        
                    searchcontent.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
                
                } else {
        
                    searchcontent.innerHTML = contentToPush.join("")
                }
        
                for(var title of data) {
        
                    const add_to = document.getElementById(data.indexOf(title) + "_ladd")
                    const test_lmore = document.getElementById(data.indexOf(title) + "_lmore")
                    const testPopup = document.getElementById(data.indexOf(title) + "_popup") 
                    const playNow = document.getElementById(data.indexOf(title) + "_playNow")
                    const copy = document.getElementById(data.indexOf(title) + "_copy")
                    const addPlaylist = document.getElementById(data.indexOf(title) + "_goPlaylist")  

                    const PlaylistManager = document.getElementById(data.indexOf(title) + "playlistManager")
                    const playlistManager_close = document.getElementById(data.indexOf(title) + "playlistManager_close")
                    const playlistSelection = document.getElementById(data.indexOf(title) + "playlistSelection")
                    const playlist_add_music = document.getElementById(data.indexOf(title) + "playlist_add_music")
                    const playlist_add_img = document.getElementById(data.indexOf(title) + "playlist_add_img")
                    const playlistAddSong = document.getElementById(data.indexOf(title) + "playlistAddSong")

                    var thumbnail = data[add_to.id.replace("_ladd", "")].thumbnail
    
                    if(!thumbnail) {

                        thumbnail = "/images/black-image.svg"
                    }
                  
                    testPopup.style.display = "none"
    
                    add_to.addEventListener("click", () => {
    
                        send("ADD_SONG", data[add_to.id.replace("_ladd", "")])
                    })

                    copy.addEventListener("click", () => {
                        navigator.clipboard.writeText(data[add_to.id.replace("_ladd", "")].uri)
                        testPopup.style.display = "none"
                    })

                    addPlaylist.addEventListener("click", () => {

                        PlaylistManager.showModal()
                        playlist_add_music.innerHTML = data[add_to.id.replace("_ladd", "")].title
                        playlist_add_img.src = thumbnail
                        playlistSelection.innerHTML = playlistAvailable
                    })

                    playlistManager_close.addEventListener("click", () => {

                        PlaylistManager.close()
                    })

                    playlistAddSong.addEventListener("click", () => {

                        
                        PlaylistManager.close()
                    
                        socket.emit("SEND/ADD_SONG_TO_PLAYLIST", playlistSelection.value , data[add_to.id.replace("_ladd", "")])

                    })
    
                    test_lmore.addEventListener("click",( ) => {
    
    
                            testPopup.style.display = "flex"
                            testPopup.style.top = yMousePos + "px"
    
                    })
    
                    testPopup.addEventListener("mouseleave", () => {
    
                            testPopup.style.display = "none"
                    
                    })
    
                    playNow.addEventListener("click", () => {
    
                        send("ADD_SONG_NOW", data[add_to.id.replace("_ladd", "")])
    
                    })

                  
        
                   
                }
               
        
            } else {
        
                searchcontent.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
        
            }

            } else {

                //https://www.youtube.com/playlist?list=PLA8VHLKYzqTvCcIKhsjGS41nG1zBpRZPy
       
                
                var playlistToPush = new Array()
                var playlist_songs = new Array()
        
            
                for(var title of results.videos) {
            
                        var PFormatduration = null
                        pdurationAll = title.milis_length
            
                        const pmaxhours = Math.floor(pdurationAll / 3600000);
            
                        var pmaxmin = Math.trunc(pdurationAll / 60000) - (Math.floor(pdurationAll / 60000 / 60) * 60);
                        var pmaxsec = Math.floor(pdurationAll / 1000) - (Math.floor(pdurationAll / 1000 / 60) * 60);
            
                      
                        if (pmaxsec < 10) {
                            pmaxsec = `0${pmaxsec}`;
                        }
            
            
                        if(pmaxhours != 0) {
            
                            if (pmaxmin < 10) {
                                pmaxmin = `0${pmaxmin}`;
                            }
            
                            
                            pmax = pmaxhours + ":" + pmaxmin + ":" + pmaxsec
                        } else {
                            pmax =  pmaxmin + ":" + pmaxsec
                        
                        }
            
                        PFormatduration = pmax

                        if(title.milis_length == 9223372036854776000) {

                            PFormatduration = "<i style='color: red;' class='fa-solid fa-circle'></i> LIVE"
                        }
            
            
                    playlist_songs.push('<div class="search_song"> <img class="search_thumbnail" src="' + title.thumbnail_url + '"><div class="search_titleSong"> <p class="search_title">' + title.title + '</p></div> <p>' + title.author.name + '</p><p>' + PFormatduration + '</p> <div class="search_buttons"><button id="' + results.videos.indexOf(title) +  '_padd" class="search_add"><i class="fa fa-plus"></i></button><button id="' + results.videos.indexOf(title) +  '_pplay" class="search_lmore"><i class="fa fa-play"></i></button></div></div>')
            
                }
            
                playlistToPush.push('<div class="apPres"><div class="apTitle"><img style="width: 20%" class="" src="' +results.thumbnail_url + '"><div style=""><p style="margin-left: 2% !important;">' + results.author.name + " - (" + results.videos.length + " titres)" +  '</p><p class="apName">' + results.title + '</p></div></div><div class="apButtons"><button  onclick="fp_play_playlist(\'' + results.url + '\')" id="'+ results.id +'_playlistplay" class="primary"><i class="fas fa-play"></i></button></div></div><hr>' + playlist_songs.join(""))
                
                if(playlistToPush.join("") == "") {
            
                    searchcontent.innerHTML = '<p class="error">Aucun morceau trouvé !</p>'
                
                } else {
            
                    searchcontent.innerHTML = playlistToPush.join("")
            
                    
                }

                
                
                
                for(var title of results.videos) {
            
                    const add_to = document.getElementById(results.videos.indexOf(title) + "_padd")
                    const playNow = document.getElementById(results.videos.indexOf(title) + "_pplay")
                    
            
                    add_to.addEventListener("click", () => {
            
                        send("FP_ADD_SONG", results.videos[add_to.id.replace("_padd", "")].url)
                    })
            
                    playNow.addEventListener("click", () => {
            
                        send("FP_ADD_SONG_NOW", results.videos[add_to.id.replace("_padd", "")].url)
            
                    })
            
                    
            
                
                }
            }
    
        }) 
    
    })
})

function fp_play_playlist(key) {
    
    send("FP_PLAY_PLAYLIST", key)
}


var timeoutId = null

socket.on("NOTIFICATION", (data) => {

    if(timeoutId) {

        clearTimeout(timeoutId)
    }

    const alertDiv = document.getElementById("alert")
    const alert_image = document.getElementById("alert_image")
    const alert_text = document.getElementById("alert_text")

    alert_image.src = data.image_src
    alert_text.innerHTML = data.text



    alertDiv.classList.add("alert_div_on")

    timeoutId = setTimeout(() => {

        alertDiv.classList.remove("alert_div_on")
    }, 4000)

    alertDiv.addEventListener("click", () => {

        
        if(timeoutId) {

            clearTimeout(timeoutId)
        }

        
        alertDiv.classList.remove("alert_div_on")

    })
})




const cPlaylistManager = document.getElementById("current_playlistManager")
const cplaylistManager_close = document.getElementById("current_playlistManager_close")
const cplaylistSelection = document.getElementById("current_playlistSelection")
const cplaylist_add_music = document.getElementById("current_playlist_add_music")
const cplaylist_add_img = document.getElementById("current_playlist_add_img")
const cplaylistAddSong = document.getElementById("current_playlistAddSong")

takeCurrent.addEventListener("click", () => {

    if(currentSong != null) {

        var thumbnail = currentSong.thumbnail

        if(!thumbnail) {

            thumbnail = "/images/black-image.svg"
        }

        cPlaylistManager.showModal()
        cplaylist_add_music.innerHTML = currentSong.title
        cplaylist_add_img.src = thumbnail
        cplaylistSelection.innerHTML = playlistAvailable

    }

})

cplaylistManager_close.addEventListener("click", () => {

    cPlaylistManager.close()
})

cplaylistAddSong.addEventListener("click", () => {

                        
    cPlaylistManager.close()
    socket.emit("SEND/ADD_SONG_TO_PLAYLIST", cplaylistSelection.value , currentSong )
    
   

})



volBox.classList.add("invisible")
listBox.classList.add("invisible")

list.addEventListener("click" , () => {

    volBox.classList.add("invisible")

    if(listBox.classList.contains('invisible')) {
        listBox.classList.remove("invisible")
      
    } else {

        listBox.classList.add("invisible")
    }
})

// Apply the width of element1 to element2


vol.addEventListener("click", () => {

    listBox.classList.add("invisible")

    if(volBox.classList.contains('invisible')) {
        volBox.classList.remove("invisible")
      
    } else {

        volBox.classList.add("invisible")
    }
 
})

volRange.addEventListener("click", () => {
    

    send("VOLUME", volRange.value)
})

volRange.addEventListener("input", () => {

   
    volTxt.innerHTML = volRange.value + "%"
})



disconnect.addEventListener("click", () => {

    get("DISCONNECT")
})




reportBtn.addEventListener("click", () => {

    report_desc.value = ""
    report_level.value = "Majeur"
    report_dialog.showModal()
})

report_close.addEventListener("click", () => {

    report_dialog.close()
})

report_send.addEventListener("click", () => {

    send("REPORT", {"level":report_level.value, "desc": report_desc.value})
    report_dialog.close()
})

loop.addEventListener("click", () => {

    get("LOOP")
})

shuffle.addEventListener("click", () => {

    get("SHUFFLE")
})



var durationAll = 0
var durationProgress = 0
var isPlaying = false
let interval;

durationBar.addEventListener("change", () => {

    send("SEEK", durationBar.value)

})


userInfo.then(user => {

    settingsBtn.style.display = "none"

    var betastar = ""
    
    if(user.beta) {

        betastar = "<p class='beta'>BETA</p>"
    }

    var textshadow = ""
   
    if(user.admin == true) {

        settingsBtn.style.display = "flex"
        isAdmin = true
        textshadow = 'box-shadow: #fcff4d 0px 0px 8px;'
    }



    if(user.user.username == "raphixscrap") {

        textshadow = 'box-shadow: #ac7599 0px 0px 8px;'
        console.log("RAPHIX !!! IS IN THE PLACE")
    }


    userInfoDiv.innerHTML = "<div class='INDEX_userInfo_name'><p class='INDEX_gbname'>" + user.user.global_name + "</p><p class='INDEX_usrname'>" + user.user.username + "</p></div><div class='INDEX_picture'><img style='" + textshadow + "' src='https://cdn.discordapp.com/avatars/" + user.user.id + "/" + user.user.avatar + "'>" + betastar + "</div>"

    
})


userInfoDiv.addEventListener("click", () => {

    if(userInfoPopup.classList.contains("invisible")) {

        userInfoPopup.classList.remove("invisible")
        userInfoPopup.style.left = (xMousePos - 110) + "px"
        userInfoPopup.style.top = yMousePos + "px"

    } 

})

userInfoPopup.classList.add("invisible")

userInfoPopup.addEventListener("mouseleave", () => {

    userInfoPopup.classList.add("invisible")
})





get("MUSIC_STATE").then(data => {
    console.log(data)
})

play.addEventListener('click', () => {

    get("PAUSE")
})

document.body.onkeyup = function(e) {

    if ((e.key == " " ||
        e.code == "Space" ||      
        e.keyCode == 32) &&
        e.srcElement.localName != "input" && e.srcElement.localName != "textarea"   
    ) {
        play.click()
    }
  }

backward.addEventListener('click', () => {

    get("BACKWARD")
})


forward.addEventListener("click", () => {

    get("FORWARD")
})

socket.on("/ALWAYS/MUSIC_STATE", (data) => {

    stopInterval()
    console.log(data)

    durationAll = 0
    durationProgress = 0
    isPlaying = false

    if(data.isOnline) {
       
        vol.classList.remove("disabled")
        shuffle.classList.remove("disabled")
        list.classList.remove("disabled")
        play.classList.remove("pri_disable")
        disconnect.classList.remove("invisible")
        volRange.classList.add("disabled")

        volRange.disabled = false
    } else {

        vol.classList.add("disabled")
        shuffle.classList.add("disabled")
        list.classList.add("disabled")
        play.classList.add("pri_disable")
        disconnect.classList.add("invisible")
        volRange.classList.add("disabled")
        volRange.disabled = true
        volRange.value = 0
        volTxt.innerHTML = "0%"
        volBox.classList.add("invisible")
      
    }

    if(data.volume) {
        volRange.step = 1
        volRange.max = 200
        volRange.min = 1
        volRange.value = Math.trunc(data.volume / 10)
        volTxt.innerHTML = Math.trunc(data.volume / 10) + "%"

        var volNum = Math.trunc(data.volume / 10)

      

    } else {

        volRange.classList.add("disabled")
        volRange.disabled = true
        volRange.value = 0
        volTxt.innerHTML = "0%"
    }

    if(data.shuffle == true) {
        shuffle.innerHTML = '<i class="third-join fa fa-shuffle"></i>'

    } else {

        shuffle.innerHTML = '<i class="fa fa-shuffle"></i>'
    }

    if(data.loop == true) {
        loop.innerHTML = '<i class="third-join fa fa-retweet"></i>'

    } else {

        loop.innerHTML = '<i class="fa fa-retweet"></i>'
    }

    if(data.current == null) {

        musicURL.innerHTML = '<img class="showPicture" src="images/black-image.svg">'
        musicTitle.innerHTML = "<p>Aucun titre joué</p>"
        loop.classList.add("invisible")
        takeCurrent.classList.add("invisible")
    } else {

        var thumbnail = data.current.thumbnail
    
        if(!thumbnail) {

            thumbnail = "/images/black-image.svg"
        }

        musicURL.innerHTML = '<img class="showPicture" src="' + thumbnail + '">'
        musicTitle.innerHTML = "<p>" + data.current.title + "</p>"
        currentSong = data.current
        takeCurrent.classList.remove("invisible")
        loop.classList.remove("invisible")
    }

    if(data.durationAll) {
        durationBar.disabled = false
        durationBar.classList.remove("grised")
        setTime()
       
        durationAll = data.durationAll
        durationProgress = data.durationNow
        durationBar.value = durationProgress
        setTime()

    } else {

       
        isPlaying = false
        durationAll = 0
        durationProgress = 0
        durationBar.disabled = true
        durationBar.classList.add("grised")
        durationBar.value = 0
        durationTextAct.innerHTML = "-:--"
        durationTextTotal.innerHTML = "-:--"
        
    }


    if(data.playing == 1) {
        play.innerHTML = '<i class="fas fa-pause"></i>'
        isPlaying = true
        startInterval()
    } else {
        
        play.innerHTML = '<i class="fas fa-play"></i>'
        isPlaying = false
       
    }

   
  
    if(data.current && data.playing == 0) {
        setTime()

    }

    if(data.durationAll == 9223372036854776000) {

        isPlaying = false
        durationAll = 0
        durationProgress = 0
        durationBar.disabled = true
        durationBar.classList.add("grised")
        durationBar.style.display = "none"
        durationBar.value = 0
        durationTextAct.innerHTML = ""
        durationTextTotal.innerHTML = "<i style='color: red;' class='fa-solid fa-circle'></i> LIVE"

    } else {

        durationBar.style.display = "unset"
    }



    if(data.queue != null) {

        var contentToPush = new Array()
        var queueNum = 0

        for(var title of data.queue) {
            queueNum += 1
            console.log(queueNum)
            console.log(data.queue.indexOf(title) + " - " + title.title)
            var thumbnail = title.thumbnail
            if(!thumbnail) {
    
            thumbnail = "/images/black-image.svg"
                            
            }
            contentToPush.push(' <div class="draggable song" id="' + data.queue.indexOf(title) + '_queue_song"> <img class="list_thumbnail" src="' + thumbnail + '"><div class="list_titleSong"> <p class="list_title">' + title.title + '</p></div> <button id="' + data.queue.indexOf(title) + '_lmove" class="list_upSong"><i class="fa fa-arrow-up"></i></button> <button id="' + data.queue.indexOf(title) + '_ldelete" class="list_delete"><i class="fa fa-trash"></i></button> </div>')
        }

        if(contentToPush.join("") == "") {
           
            listNumber.classList.add("invisible")
            listBox.innerHTML = '<p class="list_error">Aucun morceau dans la liste de lecture !</p>'
        
        } else {
            listNumber.innerHTML = '<span class="numtext">' + queueNum + '</span>'
            listNumber.classList.remove("invisible")
            listBox.innerHTML = contentToPush.join("")
        }

        //CODE INTEGER QUEUE LIST MOVE

            const container = document.getElementById('listBox');
            const draggableItems = document.querySelectorAll('.draggable');

            let draggingElement = null;

            draggableItems.forEach(item => {
                item.addEventListener('dragstart', (e) => {
                e.dataTransfer.setData('text/plain', item.innerHTML);
                draggingElement = item;
                });

                item.addEventListener('dragend', () => {
                draggingElement = null;
                setTimeout(() => {
                    item.style.display = 'flex'; // Restaure l'affichage de l'élément
                }, 0);
                updateOrder();
                });
            });

            container.addEventListener('dragover', (e) => {
                e.preventDefault();
                const afterElement = getDragAfterElement(container, e.clientY);
                if (draggingElement !== null) {
                if (afterElement == null) {
                    container.appendChild(draggingElement);
                } else {
                    const rect = afterElement.getBoundingClientRect();
                    if (e.clientY < rect.top + rect.height / 2) {
                    container.insertBefore(draggingElement, afterElement);
                    } else {
                    container.insertBefore(draggingElement, afterElement.nextElementSibling);
                    }
                }
                }
            });

            function getDragAfterElement(container, y) {
                const draggableElements = [...container.querySelectorAll('.draggable:not(.dragging)')];
                return draggableElements.reduce((closest, child) => {
                const box = child.getBoundingClientRect();
                const offset = y - box.top - box.height / 2;
                if (offset < 0 && offset > closest.offset) {
                    return { offset: offset, element: child };
                } else {
                    return closest;
                }
                }, { offset: Number.NEGATIVE_INFINITY, element: null }).element;
            }

            function updateOrder() {
                const draggableItems = document.querySelectorAll('.draggable');
                const order = [];
                draggableItems.forEach(item => {
                order.push(item.id.replace("_queue_song", ""));
                });
                console.log('Ordre des divs:', order);
                send("MOVE_QUEUE_BY_ENTIRE", order)
            }



            // END OF CODE INTEGER

        for(var title of data.queue) {

            console.log(data.queue.indexOf(title) + " - " + title.title)
            
            const titleBtn = document.getElementById(data.queue.indexOf(title)+ "_ldelete")
            const moveBtn = document.getElementById(data.queue.indexOf(title)+ "_lmove")
            
            titleBtn.addEventListener("click", () => {

               socket.emit("SEND/DELETE_QUEUE", titleBtn.id.replace("_ldelete", ""), data.queue[moveBtn.id.replace("_lmove", "")].title )
            })

            moveBtn.addEventListener("click", () => {

                send("MOVE_QUEUE", moveBtn.id.replace("_lmove", ""))

            })
        }
       

    } else {

        listBox.innerHTML = '<p class="list_error">Lancez un titre et ajoutez vos morceaux ici !</p>'
        listNumber.classList.add("invisible")
    }

})

function startInterval() {
    interval = setInterval(() => {


        if(isPlaying == true) {
            setTime()
    
        } 
    
    }, 1000)

}

function stopInterval() {
    clearInterval(interval);
}
  





function setTime() {


    durationBar.max = durationAll
    durationProgress += 1000 
    durationBar.value = durationProgress

    
    const maxhours = Math.floor(durationAll / 3600000);
    const nowhours = Math.floor(durationProgress / 3600000);

    

    var maxmin = Math.trunc(durationAll / 60000) - (Math.floor(durationAll / 60000 / 60) * 60);
    var maxsec = Math.floor(durationAll / 1000) - (Math.floor(durationAll / 1000 / 60) * 60);
    var nowmin = Math.trunc(durationProgress / 60000) - (Math.floor(durationProgress / 60000 / 60) * 60);
    var nowsec = Math.floor(durationProgress / 1000) - (Math.floor(durationProgress / 1000 / 60) * 60);

    console.log(durationAll)
    console.log(durationProgress)
    console.log("---------------------")

    var now = ""
    var max = ""


    if (maxmin < 10) {
        maxmin = `0${maxmin}`;
    }

    if (nowmin < 10) {
        nowmin = `0${nowmin}`;
    }

    if (maxsec < 10) {
        maxsec = `0${maxsec}`;
    }

    if (nowsec < 10) {
        nowsec = `0${nowsec}`;
    }

    if(maxhours != 0) {
       
        max =  maxhours + ":" + maxmin + ":" + maxsec
    } else {
        max =  maxmin + ":" + maxsec
       
    }

    if(nowhours != 0) {
       
        now =  nowhours + ":" + nowmin + ":" + nowsec
    } else {
        now =  nowmin + ":" + nowsec
       
    }

    

   durationTextAct.innerHTML = now
   durationTextTotal.innerHTML = max
}



